const superagent = require("superagent");
const Constants = require("./Constants");

class Rest {
    constructor(client) {
        this.client = client;
    }

    get(endpoint) {
        return new Promise((resolve, reject) => {
            superagent
                .get(this.client.root + endpoint)
                .set("Authorization", `Bot ${this.client.token}`)
                .set("User-Agent", Constants.userAgent)
                .then(res => {
                    return resolve(res.body);
                }).catch(err => {
                    return reject(err);
                });
        });
    }

    post(endpoint, data) {
        return new Promise((resolve, reject) => {
            superagent
                .post(this.client.root + endpoint)
                .set("Authorization", `Bot ${this.client.token}`)
                .set("User-Agent", Constants.userAgent)
                .send(data)
                .then(res => {
                    return resolve(res.body);
                }).catch(err => {
                    return reject(err);
                });
        });
    }

    put(endpoint, data) {
        return new Promise((resolve, reject) => {
            superagent
                .put(this.client.root + endpoint)
                .set("Authorization", `Bot ${this.client.token}`)
                .set("User-Agent", Constants.userAgent)
                .send(data)
                .then(res => {
                    return resolve(res.body);
                }).catch(err => {
                    return reject(err);
                });
        });
    }

    patch(endpoint, data) {
        return new Promise((resolve, reject) => {
            superagent
                .patch(this.client.root + endpoint)
                .set("Authorization", `Bot ${this.client.token}`)
                .set("User-Agent", Constants.userAgent)
                .send(data)
                .then(res => {
                    return resolve(res.body);
                }).catch(err => {
                    return reject(err);
                });
        });
    }

    delete(endpoint) {
        return new Promise((resolve, reject) => {
            superagent
                .delete(this.client.root + endpoint)
                .set("Authorization", `Bot ${this.client.token}`)
                .set("User-Agent", Constants.userAgent)
                .then(res => {
                    return resolve(res.body);
                }).catch(err => {
                    return reject(err);
                });
        });
    }
};

module.exports = Rest;