const Constants = require("../Constants");

class Self {
    constructor(client, data) {
        this.client = client;
        this.data = data;
        this.username = data.user.username;
        this.discriminator = data.user.discriminator;
        this.id = data.user.id;
        this.avatar = data.user.avatar || null;
        this.avatarURL = this.avatar ? `${this.client.cdnUrl}/avatars/${this.id}/${this.avatar}.png?size=2048` : `https://www.publicdomainpictures.net/pictures/40000/nahled/question-mark.jpg`;
    }

    setPresence(message, type = 0) {
        if (parseInt(type) > 3) throw new Error("Type must be a number between 0 (zero) and 3 (three).");
        
        this.client.ws.send(3, {
            game: {
                name: message,
                type: parseInt(type)
            },
            status: this.client.status,
            since: Date.now(),
            afk: this.client.afk
        });

        this.client.GAME = message;
        this.client.gameType = type;
    }

    setStatus(status, afk = false) {
        let allowed = ['online', 'offline','idle','dnd','invisible'];
        
        if (!allowed.includes(status.toLowerCase())) throw new Error("Status can only be online, idle, dnd, offline and invisible.");

        this.client.ws.send(3, {
            status: status.toLowerCase(),
            afk: Boolean(afk),
            since: Date.now(),
            game: this.client.game ? { name: this.client.GAME, type: this.client.gameType } : null
        });

        this.client.status = status.toLowerCase();
        this.client.afk = Boolean(afk);
    }
};

module.exports = Self;